#include "stdafx.h"
#include "access.h"

//#include <conio.h> 
#include "drv//dlportio.h" 

#define Adr_Adr 	0  	// D3 D2 = 00
#define Adr_Modi 	4   // D3 D2 = 01
#define Adr_MF 	    8	// D3 D2 = 10
#define Adr_Data 	12	// D3 D2 = 11

#define Clk_Pin		2	// D1
#define FF_Pin		16	// D4
#define Data_Out	1	// D0
#define ACK			64	// Ack  inp(Base+1)
#define Busy		128	// Busy inp(Base+1) 

// WORD Base=0x378;	external definition LPT-Port
// WORD epromtyp;   external definition 0=2708 ... 9=27c040 

BYTE Delay=2;

//********************************************************
void outport(WORD  Port, BYTE Value)
{
	DlPortWritePortUchar( (unsigned long) Port,  Value    );
}

unsigned char inport(unsigned short Port)
{
	return DlPortReadPortUchar( (unsigned long) Port );
}
//********************************************************
BOOL set_delay(BYTE idelay) 
{ 
    if (idelay) 
    {
        Delay=idelay;
        return TRUE;
    }
    return FALSE;
}

//********************************************************
BYTE get_delay()  {  return Delay;}

//********************************************************
void ms_delay(unsigned short ticks)
{
	Sleep(ticks);    
}

//********************************************************
void us_delay(unsigned short loops)
{
  {
	for (WORD ll=0;ll<loops*Delay*Delay;ll++) //loopcounting only for WINDOWS
       inport(unsigned short (Base+1));
  }
}

//********************************************************
BYTE GetData()
{
	BYTE mask=128,ReadData=0;
	
	outport(Base,Adr_Data | Clk_Pin); // S1=H S0=H (IC1)
	us_delay(1);	
	outport(Base,Adr_Data  );         // hi-clock
	us_delay(1);	
	outport(Base,Adr_Data | Clk_Pin);
	us_delay(1);

	for (int x=0; x<8; x++)
	{
		if (( inport(Base+1) & ACK) == ACK )  ReadData=BYTE(ReadData+mask);
		outport(Base,Adr_Data | FF_Pin| Clk_Pin);	      	// S1=L S0=H
		us_delay(1);
		outport(Base,Adr_Data | FF_Pin);
		us_delay(1);
		outport(Base,Adr_Data | FF_Pin| Clk_Pin);	
		us_delay(1);
		mask=BYTE(mask/2);
	}

	return ReadData;
}

BYTE GetDataIntern()
{
	BYTE mask=128,ReadData=0;

	for (int x=0; x<8; x++)
	{
		if (( inport(Base+1) & ACK) == ACK )  ReadData=BYTE(ReadData+mask);
		outport(Base,Adr_Data | FF_Pin| Clk_Pin);	      	// S1=L S0=H
		us_delay(1);
		outport(Base,Adr_Data | FF_Pin);
		us_delay(1);
		outport(Base,Adr_Data | FF_Pin| Clk_Pin);	
		us_delay(6);
		mask=BYTE(mask/2);
	}
	return ReadData;
}

//********************************************************
void CapacityMF(BYTE mData)
{
		for (int x=0; x<30;x++)
		{ 
			ResetMFBit(mData); 
			PutIC4(BYTE(mData | 0x01));
		}
}

void ResetMFBit(BYTE mData)
{ 
	//mData= BYTE(mData & 0xFE);
	PutIC4(BYTE(mData & 0xFE)); 	//reset MF
}

BOOL GetMFBit(BYTE mData, BOOL wait_type)
{
	WORD stop=200;		
    BOOL ret=FALSE;
	if (wait_type)
	{
		for (stop=2;stop>0;stop--) ms_delay(2);
	}
	else
	{
		ResetMFBit(mData);
		us_delay(10);
		BYTE whatBit=BYTE(inport(Base+1) & Busy); //read Return-bit;
		PutIC4(BYTE(mData | 0x01)); 	//set MF
		do
		{
			if  ((inport(Base+1) & Busy)!=whatBit) 
            {
                ret=TRUE;
                goto GetMFBit_Exit; //successful
            }
			else stop--;
			us_delay(10);
		}while( stop!=0);
        goto GetMFBit_Exit;	// not successful
	}
    ret=TRUE;
GetMFBit_Exit:
    ic_IC4=BYTE((ic_IC4 & 0xFD)|0x08);	// /CE=1 Vpp=0V
    PutIC4(BYTE(ic_IC4));	
    return ret;
}

//********************************************************
void PutAdr(WORD putAdr)
{
	WORD mask=0x8000;
	
	outport(Base,Adr_Adr | Clk_Pin | FF_Pin ); // enable Adr.-chips
	us_delay(1);
	for (int x=0; x<16; x++)
	{
		if ( (putAdr & mask) == mask )
		{
			outport(Base,Adr_Adr | Clk_Pin | Data_Out | FF_Pin );
			us_delay(1);
			outport(Base,Adr_Adr | Data_Out| FF_Pin );
			us_delay(1);
		}
		else
		{
			outport(Base,Adr_Adr | Clk_Pin | FF_Pin );
			us_delay(1);
			outport(Base,Adr_Adr | FF_Pin);
			us_delay(1);
		}
		mask=mask/2;
		us_delay(1);
	}
	outport(Base,Adr_Adr | Clk_Pin | FF_Pin );
	us_delay(1);
	outport(Base,Adr_Adr | Clk_Pin );
}

//********************************************************
void PutData(BYTE out_Data)
{
	BYTE mask=128;
	
	outport(Base,Adr_Data | FF_Pin| Clk_Pin);          // S1=L S0=H
	us_delay(1);
	
	for (int x=0; x<8; x++)
	{
		if ( (out_Data & mask)== mask )
		{		
			outport(Base,Adr_Data | FF_Pin| Data_Out | Clk_Pin);
			us_delay(1);
			outport(Base,Adr_Data | FF_Pin| Data_Out );
			us_delay(1);
			outport(Base,Adr_Data | FF_Pin| Data_Out | Clk_Pin);
			us_delay(1);
		}
		else
		{		
			outport(Base,Adr_Data | FF_Pin| Clk_Pin);
			us_delay(1);
			outport(Base,Adr_Data | FF_Pin);
			us_delay(1);
			outport(Base,Adr_Data | FF_Pin| Clk_Pin);
			us_delay(1);
		}
		mask=BYTE(mask/2);
	}
}

//********************************************************
void PutIC5(BYTE putData)
{
	WORD mask=0x80;
	
	outport(Base,Adr_Modi | Clk_Pin | FF_Pin ); 
	us_delay(1);
	for (int x=0; x<8; x++)
	{
		if ( (putData & mask) == mask )
		{
			outport(Base,Adr_Modi | Clk_Pin | Data_Out | FF_Pin );
			us_delay(1);
			outport(Base,Adr_Modi | Data_Out| FF_Pin );
			us_delay(1);
		}
		else
		{
			outport(Base,Adr_Modi | Clk_Pin | FF_Pin );
			us_delay(1);
			outport(Base,Adr_Modi | FF_Pin);
			us_delay(1);
		}
		mask=mask/2;
		us_delay(1);
	}
	outport(Base,Adr_Modi | Clk_Pin | FF_Pin );
	us_delay(1);
	outport(Base,Adr_Modi | Clk_Pin );
}

//********************************************************
void PutIC4(BYTE putData)
{
	WORD mask=0x80;
	
	outport(Base,Adr_MF | Clk_Pin | FF_Pin );
	us_delay(1);
	for (int x=0; x<8; x++)
	{
		if ( (putData & mask) == mask )
		{
			outport(Base,Adr_MF | Clk_Pin | Data_Out | FF_Pin );
			us_delay(1);
			outport(Base,Adr_MF | Data_Out| FF_Pin );
			us_delay(1);
		}
		else
		{
			outport(Base,Adr_MF | Clk_Pin | FF_Pin );
			us_delay(1);
			outport(Base,Adr_MF | FF_Pin);
			us_delay(1);
		}
		mask=mask/2;
		us_delay(1);
	}
	outport(Base,Adr_MF | Clk_Pin | FF_Pin );
	us_delay(1);
	outport(Base,Adr_MF | Clk_Pin );
}
  
//********************************************************
void adressesetzen(BOOL isreading, BOOL Set_HighAdr_always)
{
    //{A14=0100 0000 0000 0000=$4000 bei ..128KB ist /PGM ->auf High setzen}
    //        writeln(' 64K default 1FFFh  128K default 3FFFh  256K default 7FFFh  512K default FFFFh');
     
     if (isreading)
     {
     	if ((epromtyp==3)||(epromtyp==4)) PutAdr(WORD(adresse|0x4000));	//fr Typen (27c64 + 128) /PGM=1
     	else PutAdr(WORD(adresse));
     	//if  (epromtyp>6) 
     	if ( (Set_HighAdr_always) || (adresse>0xFFFF) )
     	{
     		switch (epromtyp)
     		{
	        	case 7:		//010
      						ic_IC5=BYTE(ic_IC5 & 0xF8);
      						ic_IC5=BYTE( ic_IC5 | (LOBYTE(HIWORD(adresse)) | 0x04)   ); //A18 to /PGM=1
      						PutIC5(ic_IC5);
        				break;
        		case 8:		//020
      						ic_IC5=BYTE(ic_IC5 & 0xF8);
      						ic_IC5=BYTE( ic_IC5 | (LOBYTE(HIWORD(adresse)) | 0x04)   ); //A18 to /PGM=1
      						PutIC5(ic_IC5);
        				break;
        		case 9:		//040
      						ic_IC5=BYTE(ic_IC5 & 0xF8);
      						ic_IC5=BYTE( ic_IC5 | LOBYTE(HIWORD(adresse))   ); //A16..A18
      						PutIC5(ic_IC5);
        				break;
      		}

	     }
      }
      else 
      {
      	PutAdr(WORD(adresse));
     	if ( (Set_HighAdr_always) || (adresse>DWORD(0xFFFF)) )
     	{
			ic_IC5=BYTE(ic_IC5 & 0xF8);
			ic_IC5=BYTE( ic_IC5 | LOBYTE(HIWORD(adresse))   ); //A16..A18
			PutIC5(ic_IC5);
	    }
      }
}
//********************************************************

WORD epromer_select(BOOL First)
{
    //search at 0x278 and 0x378hex the epromercode
    BYTE ident=0;
    BYTE getvalue=0;
    WORD Basetmp=Base;
    if (First==TRUE)
    {
    	PutData(0x55); 
    	if (GetDataIntern()!=0x55)  if (Basetmp==0x278) Base=0x378; else Base=0x278;   	
	    
    	for (BYTE tc=1; tc!=0;tc=BYTE(tc*2))
    	{
    		PutData(tc);
   			if (GetDataIntern()!=tc) { ident=1; break ; }
   		}
		char tmp[250];
		if (ident==0)
		{
			wsprintf(tmp,"epromer  found at LPT: (%lxh)",DWORD(Basetmp));   
			if (Base==Basetmp)	AfxMessageBox(tmp,MB_ICONINFORMATION,0);			
			Basetmp=Base;			
		}
		else
		{
				Base=Basetmp;
				Basetmp=1;					//wrong lpt or no epromer
				wsprintf(tmp,"epromer not found at LPT (%lxh)\ndefault value: %lxh\nreturn value: %lxh",DWORD(Base),DWORD(tc),DWORD(getvalue));
				AfxMessageBox(tmp,MB_ICONSTOP,0);
		}
	}
	else	//first==false
	{
    	for (BYTE tc=1; tc!=0;tc=BYTE(tc*2))
    	{   			
   			PutData(tc);
   			if (GetDataIntern()!=tc) { Basetmp=1; break ; }
   		}
	}
    return Basetmp;
}

